#include <stdlib.h> /* calloc, free, qsort */
#include <stdio.h> /* printf */
#include <unistd.h> /* sbrk */

int data_var = 0; /* Dans les DATA (donnes gloabales initialiss)*/
int bss_var; /* Dans BSS (donnes gloabales non initialiss) */

enum {text,data,bss,bheap,heap,bstack,stack,fin};

struct segment {
  void *adresse;
  char *nom;
} 
s[fin] =
  {
    {NULL,"code"},
    {NULL,"donnes"},
    {NULL,"bss"},
    {NULL,"debut tas"},
    {NULL,"tas"},
    {NULL,"debut pile"},
    {NULL,"pile"}
  }
;

int comparer(const void *p1, const void *p2)
{
  const struct segment *s1=p1, *s2=p2;

  if(s1->adresse < s2->adresse)
    return -1;
  
  if(s1->adresse == s2->adresse)
    return 0;

  return 1;
}

/* main est stock dans le segment text */
int main(void) { 
  
  int i;       /* dans la pile */
  
  s[text].adresse = main;
  s[bss].adresse = &bss_var;
  s[data].adresse = &data_var;
  s[bstack].adresse = &i;
  {
    int x;
    s[stack].adresse = &x;
  }
  
  s[bheap].adresse = sbrk(0); /* adresse de base du tas, 
				 avant le premier malloc    */
  s[heap].adresse = calloc(1,sizeof(int)); /* premier adresse libre du tas, 
					      aprz le premier malloc    */
  free(s[heap].adresse);
    
  qsort(s,fin,sizeof(struct segment),comparer);
  
  for(i=fin-1;i>=0;i--)
    printf("%10s %10p\n",s[i].nom,s[i].adresse);
  
  return 0;
}
