#include <stdio.h> /* printf */
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "file.h"
#include "simulateur.h"

/* Defauts */
int choix=FIFO;
float quantum=0.1,overhead=0;

void
usage()
{
  printf("Usage :  faire\n");
  return;
}

void
sortir(char * message)
{
  printf("%s\n",message);
  usage();
  exit(EXIT_FAILURE);
}

void
traiter_options(int argc, char * argv[])
{
  int opt;
  
  /* getopt : voir man 3 getopt */
  while((opt=getopt(argc,argv,"+fetrq:o:h")) != EOF)
    {
      switch(opt)
	{
	case 'f': 
	  choix=FIFO; break;
	case 'e': 
	  choix=PCTE; break;
	case 't': 
	  choix=TOURNIQUET; break;
	case 'r': 
	  choix=PCTER; break;
	case 'q':
	  if((quantum=atof(optarg)) <= 0)
	    sortir("L'option q ncessite d'un flottant non nul");
	  break;
	case 'o':
	  if((overhead=atof(optarg)) < 0)
	    sortir( "L'option o ncessite d'un flottant"
		   " posistif");
	  break;
	case 'h':
	  usage();
	  exit(EXIT_SUCCESS);
	default:
	  sortir("");
	}
    }
}


/* Initialise la file d'entre  partir du fichier */
struct file *
lire_file_entree(char * nom_fichier)
{
  FILE * fichier; 
  struct file *f = new_file();
  float t_execution, t_entrefile;
  
  if( (fichier = fopen(nom_fichier,"r")) == NULL)
    sortir("Fichier non trouv");
  
  while(fscanf(fichier,"%f ; %f ;",&t_execution,&t_entrefile) == 2)
    {
      struct processus *proc;
      NEW(proc,struct processus);
      
      proc->t_ajoute=t_entrefile;
      proc->t_exec=t_execution;
      file_enqueue(f,proc);
    }
  
  fclose(fichier);

  return f;
}

int main(int argc, char *argv[])
{
  int no_processus;
  struct file * file_entree;

  /* Options */
  traiter_options(argc,argv);
  if(optind != argc -1)
    sortir("J'ai besoin d'un (et un seul) nom"
	   " de fichier en paramtre\n");
  /* Lecture des donnes */
  file_entree=lire_file_entree(argv[optind]);

  no_processus=file_no_procs(file_entree);
  
  /* Simulations */
  simulateur(file_entree,choix,overhead,quantum);

  /* Affichage */
  printf("Temps de traitement moyen : %.2f\n", 
	 t_traitement_tot/no_processus);
  printf("Algorithme : %s", algo_name[choix]);
  if(choix == PCTER || choix == TOURNIQUET)
    printf(", quantum : %f, overhead : %f", quantum, overhead);
  printf("\n");

  return 0;
}

